
use <Material.scad>;
use <../../WebWeaver/scad/Util.scad>;

$fs = 0.35;
$fa = 2 * $fs;

$str = 3;
$E   = 0.01;  // ε

// note: using constant functions here because they get imported via `use`

function pcb_t() = 1.6;

function pcb_w() = 75.5;
function pcb_h() = 65.0;

function pcb_edge_r() = 3;

function M3() = 3.2;

// x is all the same and y is +- 18.5 and 0 as there are three of them
function terminals_x() = 28.75;
function terminals_y() = 18.50;

// tpow = power terminal
function tpow_x()  = -30.25;
function tpow_y()  =  14.50;
function tpow_sx() =  11.00;
function tpow_sy() =  11.50;
function tpow_sz() =   3.00;  // TODO: measure!!

// co = cut-out
co_w =   6.1;
co_h =  18.0;
co_x = -34.7;
co_y =  -8.6;



module pcbScrewHoles(tz=0) {
  for (tx=[-32.75, 5.75], ty=[-27.5, 27.5]) translate([tx, ty, tz]) children();
}

module pcbOutline() {

  difference() {
    roundRect(pcb_w(), pcb_h(), pcb_edge_r(), center=true);
    
    pcbScrewHoles() circle(d=M3());
    
    translate([co_x, co_y, 0]) square([co_w + $E, co_h], center=true);
  }
}

module pcb3D(pcb_t=pcb_t()) {
  FR4()
    linear_extrude(pcb_t())
      pcbOutline();

  if ($preview) {

    pcbScrewHoles()
      Solder()
        difference() {
          translate([0, 0, -$E]) cylinder(d=M3()*2, h=pcb_t()+2*$E);
          translate([0, 0, -$E*2]) cylinder(d=M3()-$E,   h=pcb_t()+4*$E);
        }

    Solder()
      translate([tpow_x(), tpow_y(), pcb_t() - $E])
        cube([tpow_sx(), tpow_sy(), tpow_sz()], center=true);
  }
}

pcb3D();
